/************************************************************************************/
/*  Program name CAPGLEXT_INTERFACE.sql                                             */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 6 FEB, 2005   NIP Karen         First created                                    */
/************************************************************************************/
SET VERIFY OFF
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPGLEXT_INTERFACE';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPGL_INTERFACE.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT 
		GJI.*
	FROM   
		GL_INTERFACE		GJI,
		GL_SETS_OF_BOOKS	SOB
	WHERE	GJI	.SET_OF_BOOKS_ID			=	SOB.SET_OF_BOOKS_ID
	AND		SUBSTR(SOB.SHORT_NAME,5,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.STATUS||CHR(9)||
					C1.SET_OF_BOOKS_ID||CHR(9)||
				C1.ACCOUNTING_DATE||CHR(9)||
				C1.CURRENCY_CODE||CHR(9)||
				C1.DATE_CREATED||CHR(9)||
					C1.CREATED_BY||CHR(9)||
				C1.ACTUAL_FLAG||CHR(9)||
				C1.USER_JE_CATEGORY_NAME||CHR(9)||
				C1.USER_JE_SOURCE_NAME||CHR(9)||
				C1.CURRENCY_CONVERSION_DATE||CHR(9)||
					C1.ENCUMBRANCE_TYPE_ID||CHR(9)||
					C1.BUDGET_VERSION_ID||CHR(9)||
				C1.USER_CURRENCY_CONVERSION_TYPE||CHR(9)||
				C1.CURRENCY_CONVERSION_RATE||CHR(9)||
				C1.AVERAGE_JOURNAL_FLAG||CHR(9)||
				C1.ORIGINATING_BAL_SEG_VALUE||CHR(9)||
				C1.SEGMENT1||CHR(9)||
				C1.SEGMENT2||CHR(9)||
				C1.SEGMENT3||CHR(9)||
				C1.SEGMENT4||CHR(9)||
				C1.SEGMENT5||CHR(9)||
				C1.SEGMENT6||CHR(9)||
				C1.SEGMENT7||CHR(9)||
				C1.SEGMENT8||CHR(9)||
				C1.SEGMENT9||CHR(9)||
				C1.SEGMENT10||CHR(9)||
				C1.SEGMENT11||CHR(9)||
				C1.SEGMENT12||CHR(9)||
				C1.SEGMENT13||CHR(9)||
				C1.SEGMENT14||CHR(9)||
				C1.SEGMENT15||CHR(9)||
				C1.SEGMENT16||CHR(9)||
				C1.SEGMENT17||CHR(9)||
				C1.SEGMENT18||CHR(9)||
				C1.SEGMENT19||CHR(9)||
				C1.SEGMENT20||CHR(9)||
				C1.SEGMENT21||CHR(9)||
				C1.SEGMENT22||CHR(9)||
				C1.SEGMENT23||CHR(9)||
				C1.SEGMENT24||CHR(9)||
				C1.SEGMENT25||CHR(9)||
				C1.SEGMENT26||CHR(9)||
				C1.SEGMENT27||CHR(9)||
				C1.SEGMENT28||CHR(9)||
				C1.SEGMENT29||CHR(9)||
				C1.SEGMENT30||CHR(9)||
				C1.ENTERED_DR||CHR(9)||
				C1.ENTERED_CR||CHR(9)||
				C1.ACCOUNTED_DR||CHR(9)||
				C1.ACCOUNTED_CR||CHR(9)||
				C1.TRANSACTION_DATE||CHR(9)||
				C1.REFERENCE1||CHR(9)||
				C1.REFERENCE2||CHR(9)||
				C1.REFERENCE3||CHR(9)||
				C1.REFERENCE4||CHR(9)||
				C1.REFERENCE5||CHR(9)||
				C1.REFERENCE6||CHR(9)||
				C1.REFERENCE7||CHR(9)||
				C1.REFERENCE8||CHR(9)||
				C1.REFERENCE9||CHR(9)||
				C1.REFERENCE10||CHR(9)||
				C1.REFERENCE11||CHR(9)||
				C1.REFERENCE12||CHR(9)||
				C1.REFERENCE13||CHR(9)||
				C1.REFERENCE14||CHR(9)||
				C1.REFERENCE15||CHR(9)||
				C1.REFERENCE16||CHR(9)||
				C1.REFERENCE17||CHR(9)||
				C1.REFERENCE18||CHR(9)||
				C1.REFERENCE19||CHR(9)||
				C1.REFERENCE20||CHR(9)||
				C1.REFERENCE21||CHR(9)||
				C1.REFERENCE22||CHR(9)||
				C1.REFERENCE23||CHR(9)||
				C1.REFERENCE24||CHR(9)||
				C1.REFERENCE25||CHR(9)||
				C1.REFERENCE26||CHR(9)||
				C1.REFERENCE27||CHR(9)||
				C1.REFERENCE28||CHR(9)||
				C1.REFERENCE29||CHR(9)||
				C1.REFERENCE30||CHR(9)||
				C1.JE_BATCH_ID||CHR(9)||
				C1.PERIOD_NAME||CHR(9)||
				C1.JE_HEADER_ID||CHR(9)||
				C1.JE_LINE_NUM||CHR(9)||
					C1.CHART_OF_ACCOUNTS_ID||CHR(9)||
				C1.FUNCTIONAL_CURRENCY_CODE||CHR(9)||
					C1.CODE_COMBINATION_ID||CHR(9)||
				C1.DATE_CREATED_IN_GL||CHR(9)||
				C1.WARNING_CODE||CHR(9)||
				C1.STATUS_DESCRIPTION||CHR(9)||
				C1.STAT_AMOUNT||CHR(9)||
				C1.GROUP_ID||CHR(9)||
				C1.REQUEST_ID||CHR(9)||
					C1.SUBLEDGER_DOC_SEQUENCE_ID||CHR(9)||
				C1.SUBLEDGER_DOC_SEQUENCE_VALUE||CHR(9)||
				C1.ATTRIBUTE1||CHR(9)||
				C1.ATTRIBUTE2||CHR(9)||
				C1.GL_SL_LINK_ID||CHR(9)||
				C1.GL_SL_LINK_TABLE||CHR(9)||
				C1.ATTRIBUTE3||CHR(9)||
				C1.ATTRIBUTE4||CHR(9)||
				C1.ATTRIBUTE5||CHR(9)||
				C1.ATTRIBUTE6||CHR(9)||
				C1.ATTRIBUTE7||CHR(9)||
				C1.ATTRIBUTE8||CHR(9)||
				C1.ATTRIBUTE9||CHR(9)||
				C1.ATTRIBUTE10||CHR(9)||
				C1.ATTRIBUTE11||CHR(9)||
				C1.ATTRIBUTE12||CHR(9)||
				C1.ATTRIBUTE13||CHR(9)||
				C1.ATTRIBUTE14||CHR(9)||
				C1.ATTRIBUTE15||CHR(9)||
				C1.ATTRIBUTE16||CHR(9)||
				C1.ATTRIBUTE17||CHR(9)||
				C1.ATTRIBUTE18||CHR(9)||
				C1.ATTRIBUTE19||CHR(9)||
				C1.ATTRIBUTE20||CHR(9)||
				C1.CONTEXT||CHR(9)||
				C1.CONTEXT2||CHR(9)||
				C1.INVOICE_DATE||CHR(9)||
				C1.TAX_CODE||CHR(9)||
				C1.INVOICE_IDENTIFIER||CHR(9)||
				C1.INVOICE_AMOUNT||CHR(9)||
				C1.CONTEXT3||CHR(9)||
				C1.USSGL_TRANSACTION_CODE||CHR(9)||
				C1.DESCR_FLEX_ERROR_MESSAGE||CHR(9)||
				C1.JGZZ_RECON_REF||CHR(9)||
				C1.REFERENCE_DATE||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetSOBShortName(C1.SET_OF_BOOKS_ID)||CHR(9)||
				CAPBREXT_COMMON.GetEncumType(C1.ENCUMBRANCE_TYPE_ID)||CHR(9)||
				CAPBREXT_COMMON.GetBudgetName(C1.BUDGET_VERSION_ID)||CHR(9)||
				CAPBREXT_COMMON.GetFlexStrCode(C1.CHART_OF_ACCOUNTS_ID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.CODE_COMBINATION_ID)||CHR(9)||
				CAPBREXT_COMMON.GetDocSeqName(C1.SUBLEDGER_DOC_SEQUENCE_ID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/